<template>
    <div>
        <breadcrumb-component title="Formas de pagamento" :pages="breadPages"/>

        <panel-component title="Listar formas de pagamento" :pages="breadPages">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'payments.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar forma pagamento
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Conta bancária</th>
                        <th>Nº. máx de parcelas</th>
                        <th>Intervalo entre parcelas</th>
                        <th>1º  parcela</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="payment in payments">
                        <td>{{payment.name}}</td>
                        <td>
                            {{payment.bank.name}}
                        </td>
                        <td>{{payment.parcelas}}</td>
                        <td>{{payment.intervalo}} dias</td>
                        <td>{{payment.primeira_parcela}} dias</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'payments.edit', params: {id: payment.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(payment)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'payments', name: 'Financeiro', active: false},
                    {link: 'payments', name: 'Formas de pagamento', active: false},
                    {link: 'payments', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadPayments()
        },

        computed: {
            payments() {
                return this.$store.state.payments.items
            }
        },

        methods: {
            loadPayments() {
                this.$store.dispatch('loadPayments')
            },

            confirmDestroy(payment) {
                this.$snotify.confirm(`Deseja realmente apagar a forma de pagamento: ${payment.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyPayment(payment.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyPayment(id) {
                this.$store.dispatch('destroyPayment', id)
                    .then(() => {
                        this.loadPayments()
                        this.$snotify.success('Forma de pagamento apagada com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar a forma de pagamento!', 'Error')
                    })
            }
        }
    }
</script>